//---------------------------------------------------------------------------


#pragma hdrstop

#include "uSrJPG.h"


//---------------------------------------------------------------------------

#pragma package(smart_init)
//----------------------------------------------------------------------------------------
void _SrJPG::fnClearHead(SrHead &Head)
{
   Head.dAllTime=0;
   Head.iCo1Len = 0;
   Head.iRowLen = 0;
   Head.iPushDataCnt=0;
   Head.iVS=0; Head.iWidth=0; Head.iHeight=0; Head.iExpectFrameRate=0; Head.fRealFrameRate=0;
   Head.iHeadDataCnt=0; Head.iHeadDataSize = 0; Head.iVPGSize=0;
   ::ZeroMemory((void *)Head.szJpgHead, sizeof(char) * g_iJpgHeadLen);
}
//---------------------------------------------------------------------------------
void _SrJPG::fnInitHead(SrHead &Head)
{
   Head.iVS=1.0;
   Head.iWidth=480;
   Head.iHeight=480;
   Head.iHeadDataCnt=0;
   Head.iPushDataCnt=0;
   Head.fRealFrameRate=0;
   Head.iVPGSize=0;
   Head.dAllTime=0;
   ::ZeroMemory((void *)Head.szJpgHead, sizeof(char) * g_iJpgHeadLen);
}
//------------------------------------------------------------------------------------------
_SrJPG::_SrJPG(TComponent* AOwner)
{
   m_iMaxTime= 3600*1;
   m_iPlayIndx=0;
   m_iCmpQual=50;
   m_fPlayRate=1.0;
   m_iFilter = 20;
   m_iColLenW=1;
   m_iRowLenW=1;
   m_iColLenR=1;
   m_iRowLenR=1;
   m_iSysCx = GetSystemMetrics(SM_CXSCREEN);
   m_iSysCy = GetSystemMetrics(SM_CYSCREEN);
   m_FileStrmW=0;
   m_FileStrmR=0;
   m_TGTWnd=0;
   m_bSaveing = false;
   m_StartRecord.Val=0;
   m_FnPt.OnCmpr=0;
   m_FnPt.OnDeCmpr=0;
   m_FnPt.OnMtrPlay=0;
   m_FnPt.OnDeCmprFinish=0;
   m_FnPt.OnCmprFinish=0;
   m_HeadDataPre=0;
   m_szHeadDataW=0;
   m_szHeadDataR=0;
   m_bImgCmp =0;
   m_zc = zcDefault;
   m_fPlaySclx = 1.0;
   m_fPlayScly = 1.0;

   m_memTmp = new TMemoryStream;
   m_ImgTmp = new TImage(0);
   m_JpgTmpR = new TJPEGImage();

   m_rTimer = new TTimer(AOwner);
   m_rTimer->Enabled=false;
   m_rTimer->OnTimer=fnOnrTime;
   m_pTimer = new TTimer(AOwner);
   m_pTimer->Enabled=false;
   m_pTimer->OnTimer=fnOnpTime;

   fnCreateBuff();
   m_ansTmpName="VPG.tmp";
   m_ansExt="vpg";
   fnSetTmpDir();
   fnDelTmpFile();

}
//--------------------------------------------------------------------------------
_SrJPG::~_SrJPG()
{
   delete m_JpgTmpR;
   delete m_ImgTmp;
   delete m_memTmp;
   delete m_Tank;
   delete m_MtrImgW;
   delete m_MtrImgR;
   delete m_MtrImgP;
   delete m_rTimer;
   delete m_pTimer;
   fnClearHeadData(m_HeadDataPre, m_vpgHeadW.iCo1Len, m_vpgHeadW.iRowLen);
   fnClearImgCmp(m_bImgCmp, m_vpgHeadW.iCo1Len, m_vpgHeadW.iRowLen);


   fnClearHeadDataIndxBuf(m_szHeadDataW);
   fnClearHeadDataIndxBuf(m_szHeadDataR);

   delete [] m_szImgBuf;
   if(m_FileStrmW)
      delete m_FileStrmW;


   if(m_FileStrmR)
      delete m_FileStrmR;
}
//---------------------------------------------------------------------------------
void _SrJPG::fnCreateBuff()
{
   m_iImgBufLen = 1024*1024*1;
   m_Tank = new _Tank(1024*1024*8);
   m_MtrImgW = new _ImgMatrix();
   m_MtrImgR = new _ImgMatrix();
   m_MtrImgP = new _ImgMatrix();
   m_szImgBuf    =  new char[m_iImgBufLen];
   ::ZeroMemory(m_szImgBuf, sizeof(char) * m_iImgBufLen);
}
//-------------------------------------------------------------------------------
void _SrJPG::fnInitImgCmp(bool **&ImgCmp, int iColLen, int iRowLen)
{
   static int iColLenPre = iColLen;
   static int iRowLenPre = iRowLen;
   fnClearImgCmp(ImgCmp, iColLenPre, iRowLenPre);
   fnCreateImgCmp(ImgCmp, iColLen, iRowLen);
   iColLenPre = iColLen;
   iRowLenPre = iRowLen;
}
//---------------------------------------------------------------------
void _SrJPG::fnCreateImgCmp(bool **&ImgCmp, int iColLen, int iRowLen)
{
   ImgCmp = new bool* [iColLen];
   for (int i=0;i<iColLen ;i++)
      ImgCmp[i] = new bool [iRowLen];

   for (int i=0;i<iColLen ;i++){
      for (int j=0;j<iRowLen ;j++){
         ImgCmp[i][j]= true;
      }
   }
}
//--------------------------------------------------------------------
void _SrJPG::fnClearImgCmp(bool **&ImgCmp, int iColLen, int iRowLen)
{
   if(!ImgCmp) return;
   for (int i=0;i<iColLen ;i++)
      delete [] ImgCmp[i];
   delete ImgCmp;
   ImgCmp = 0;
}
//-------------------------------------------------------------------------------
void _SrJPG::fnInitHeadData(SrHeadData **&HeadData, int iColLen, int iRowLen)
{
   static int iColLenPre = iColLen;
   static int iRowLenPre = iRowLen;
   fnClearHeadData(HeadData, iColLenPre, iRowLenPre);
   fnCreateHeadData(HeadData, iColLen, iRowLen);
   iColLenPre = iColLen;
   iRowLenPre = iColLen;
}
//----------------------------------------------------------------------------------
void _SrJPG::fnCreateHeadData(SrHeadData **&HeadData, int iColLen, int iRowLen)
{
   HeadData = new SrHeadData* [iColLen];
   for (int i=0;i<iColLen ;i++)
      HeadData[i] = new SrHeadData [iRowLen];
   for (int i=0;i<iColLen ;i++){
      for (int j=0;j<iRowLen ;j++){
         ZeroMemory(&HeadData[i][j], sizeof(SrHeadData) );
      }
   }

}
//---------------------------------------------------------------------------------
void _SrJPG::fnClearHeadData(SrHeadData **&HeadData, int iColLen, int iRowLen)
{
   if(!HeadData) return;
   for (int i=0;i<iColLen ;i++)
      delete [] HeadData[i];
   delete HeadData;
   HeadData =0;
}
//--------------------------------------------------------------------------------
void _SrJPG::fnInitHeadDataIndxBuf(char *&sz, int iLen)
{
   fnClearHeadDataIndxBuf(sz);
   fnCreateHeadDataIndxBuf(sz, iLen);
}
//------------------------------------------------------------------------------
void _SrJPG::fnCreateHeadDataIndxBuf(char *&sz, int iLen)
{
   sz = new char[iLen];
   ::ZeroMemory(sz, sizeof(char) * iLen);
}
//-------------------------------------------------------------------------------
void _SrJPG::fnClearHeadDataIndxBuf(char *&sz)
{
   if(!sz) return;
   delete [] sz;
   sz = 0;
}
//--------------------------------------------------------------------------------
void _SrJPG::fnSetPlayScl(float fx, float fy)
{
   m_fPlaySclx = fx;
   m_fPlayScly = fy;
}
//----------------------------------------------------------------------------------
void _SrJPG::fnSetFilter(int iVar)
{
   m_iFilter = iVar;
}
//----------------------------------------------------------------------------------
void _SrJPG::fnSetRecordColRow(int iColLen, int iRowLen)
{
   m_iColLenW = iColLen;
   m_iRowLenW = iRowLen;
}
//--------------------------------------------------------------------------------
void _SrJPG::fnSetCompressionLevel(TZCompressionLevel zc)
{
   m_zc = zc;
}
//---------------------------------------------------------------------------------
void _SrJPG::fnSetCompressionQuality(int iVar)
{
   m_iCmpQual = iVar;
}
//-------------------------------------------------------------------------------
void _SrJPG::fnSetInterFace(strFnPt FnPt)
{
   m_FnPt = FnPt;
}
//-----------------------------------------------------------------------------------
void _SrJPG::fnSetRecordFrame(int iVar)
{
   m_iRecordFrame = iVar;
}
//-----------------------------------------------------------------------------------
void _SrJPG::fnSetPlayRate(float fVar)
{
   m_fPlayRate = fVar;
}
//-------------------------------------------------------------
void __fastcall _SrJPG::fnOnrTime(TObject *Sender)
{
   if(m_vpgHeadW.iHeadDataCnt >= (m_iMaxTime*m_iColLenW*m_iRowLenW*m_vpgHeadW.iExpectFrameRate))
      return;
   fnGetBMPFromWnd(m_TGTWnd);
   fnPushTank(m_MtrImgW);
}
//---------------------------------------------------------------------------------
void _SrJPG::fnRecording(HWND hWnd)
{
   m_TGTWnd = hWnd;
   fnInitRecord(hWnd);
}
//----------------------------------------------------------------------------------
void _SrJPG::fnGetTGTWndDim(HWND hWnd)
{
   RECT rt=TRect(0,0,0,0);
   if(hWnd){
      if(IsWindow(hWnd)){
         GetWindowRect(hWnd, &rt);
         m_iTGTTop = rt.top;
         m_iTGTLeft = rt.left;
         m_iTGTWidth  = abs(rt.right - rt.left);
         m_iTGTHeight = abs(rt.bottom - rt.top);
      }
   }
   else{
      m_iTGTTop = 0;
      m_iTGTLeft = 0;
      m_iTGTWidth  = m_iSysCx;
      m_iTGTHeight = m_iSysCy;
   }
}
//---------------------------------------------------------------------------------
void _SrJPG::fnInitRecord(HWND hWnd)
{
   RECT rt=TRect(0,0,0,0);
   if(IsWindow(hWnd))
      GetWindowRect(hWnd, &rt);

   fnInitHead(m_vpgHeadW);
   m_MtrImgW->fnInitMtr(m_iColLenW, m_iRowLenW);
   m_MtrImgP->fnInitMtr(m_iColLenW, m_iRowLenW);
   m_MtrImgW->fnSetJpgQul(m_iCmpQual);
   m_MtrImgP->fnSetJpgQul(m_iCmpQual);
   fnInitHeadData(m_HeadDataPre, m_iColLenW, m_iRowLenW);
   fnInitImgCmp(m_bImgCmp, m_iColLenW, m_iRowLenW);
   Sleep(10);

   fnGetTGTWndDim(hWnd);
   m_vpgHeadW.iExpectFrameRate = m_iRecordFrame;
   m_vpgHeadW.iWidth  = abs(rt.right - rt.left);
   m_vpgHeadW.iHeight = abs(rt.bottom - rt.top);
   m_vpgHeadW.iCo1Len = m_iColLenW;
   m_vpgHeadW.iRowLen = m_iRowLenW;
   m_vpgHeadW.iHeadDataSize = m_iColLenW*m_iRowLenW*m_iMaxTime*m_iRecordFrame*sizeof(SrHeadData);// _SrHeadData
   fnInitHeadDataIndxBuf(m_szHeadDataW, m_vpgHeadW.iHeadDataSize);
   m_ansTmpName = FormatDateTime("YYMMDD_HHMMSS", Now() )+".tmp";
   fnCreateTmpFile(m_ansTmpName);
   m_rTimer->Interval = (1000./m_vpgHeadW.iExpectFrameRate);
   m_rTimer->Enabled  = true;
   m_StartRecord = fnGetNow();
}
//-----------------------------------------------------------------------------------
void _SrJPG::fnRecordingSpace(bool bPause)
{
   if(m_StartRecord.Val)
      m_rTimer->Enabled=!bPause;
}
//---------------------------------------------
void _SrJPG::fnPlaySpace(bool bPause)
{
   if(m_FileStrmR)
      m_pTimer->Enabled=!bPause;
}
//------------------------------------------
bool _SrJPG::fnMemCmp(TMemoryStream *mem1, TMemoryStream *mem2)
{
   bool bRtn=true;
   if(mem1->Size == mem2->Size){
    //  if(!memcmp(mem1->Memory, mem2->Memory, mem1->Size))
         bRtn=false;
   }
   return bRtn;
}
//---------------------------------------------------------------------------
void _SrJPG::fnPushTank(_ImgMatrix *MtrNew)
{
   TMemoryStream *memTmp;
   String ansTT;
   TImage *ImgTmp;
   SrHeadData hd;
   float fSec=0;
   static unsigned __int64 iDPos=0;
   TDateTime T1, T2;
   TDateTime Tms = EncodeTime(0, 0, 0, 1);//1 minsecond
   m_vpgHeadW.dAllTime = fnGetNow().Val - m_StartRecord.Val;
   fnReadHeadData(m_szHeadDataW, m_vpgHeadW.iHeadDataCnt-1, hd);
   fSec = hd.dTime/(1000.*Tms.Val);

   for (int i=0;i<m_iColLenW ;i++){
      for (int j=0;j<m_iRowLenW ;j++){
         if(!m_bImgCmp[i][j]){  //same
            hd = m_HeadDataPre[i][j];
            hd.dTime = fnGetNow().Val - m_StartRecord.Val;
            fnWriteHeadData(m_szHeadDataW, m_vpgHeadW.iHeadDataCnt, hd);
         }
         else{
            memTmp = MtrNew->fnGetJpgMem(i,j);
            hd.iPos  =  m_ihdPos;
            hd.iSize =  memTmp->Size - g_iJpgHeadLen;
            m_ihdPos += hd.iSize;
            hd.dTime =  fnGetNow().Val - m_StartRecord.Val;

            fnWriteHeadData(m_szHeadDataW, m_vpgHeadW.iHeadDataCnt, hd);

            if(m_Tank->fnPush( (((char *)memTmp->Memory) + g_iJpgHeadLen), hd.iSize) == -1)
               fnSaveVPGTmp();
            m_vpgHeadW.iPushDataCnt++;
            m_HeadDataPre[i][j] = hd;
         }
         m_vpgHeadW.iHeadDataCnt++;
      }
   }
   if(fSec!=0)
      m_vpgHeadW.fRealFrameRate = (m_vpgHeadW.iHeadDataCnt/(m_iColLenW*m_iRowLenW))/fSec ;
}
//-------------------------------------------------------------------------
void _SrJPG::fnSaveVPGTmp()
{
   int iDumpLen=0, iHeadSz;
   void *vp;
   iHeadSz = sizeof(m_vpgHeadW);
   m_ansTmpFile = m_ansTmpDir+"\\"+m_ansTmpName;

   if(!FileExists(m_ansTmpFile)){
      Application->MessageBoxA("Create vpg.tmp Error","");
      return;
   }
   m_Tank->fnDump(vp, iDumpLen);
   m_vpgHeadW.iVPGSize+=iDumpLen;
   m_FileStrmW->Seek(0, soFromBeginning);
   m_FileStrmW->WriteBuffer((void *)&m_vpgHeadW, iHeadSz);
   m_FileStrmW->Seek(iHeadSz, soFromBeginning);
   m_FileStrmW->WriteBuffer(m_szHeadDataW, m_vpgHeadW.iHeadDataSize);
   m_FileStrmW->Seek(0, soFromEnd);
   m_FileStrmW->Write(vp, iDumpLen);


}
//------------------------------------------------------------------------
void _SrJPG::fnReadHeadData(char *pData, __int64 indx, SrHeadData &hd)
{
   unsigned int iOfx;
   if(indx>=0) iOfx = indx*sizeof(hd);
   else        iOfx =0;
   memcpy((void *)&hd, (void *)(pData + iOfx), sizeof(hd));
}
//-------------------------------------------------------------------------------
void _SrJPG::fnWriteHeadData(char *pData, __int64 indx, SrHeadData hd)
{
   unsigned int iOfx;
   if(indx>=0) iOfx = indx*sizeof(hd);
   else        iOfx =0;
   memcpy((void *)(pData + iOfx),(void *)&hd, sizeof(hd));
}
//-------------------------------------------------------------------------------------
void _SrJPG::fnGetBMPFromWnd(HWND hWnd)
{
   HDC dcS=0;
   dcS = GetDC(0);// hWnd

   m_ImgTmp->Height=m_iTGTHeight;
   m_ImgTmp->Width=m_iTGTWidth;
   m_ImgTmp->Picture->Bitmap->Width = m_iTGTWidth;
   m_ImgTmp->Picture->Bitmap->Height = m_iTGTHeight;

   BitBlt(m_ImgTmp->Canvas->Handle ,0 ,0, m_iTGTWidth, m_iTGTHeight, dcS, m_iTGTLeft, m_iTGTTop, SRCCOPY);
   TImage *ImgTmpNow, *ImgTmpOld;
   int immW = m_iTGTWidth/m_iColLenW;
   int immH = m_iTGTHeight/m_iRowLenW;
   for (int i=0;i<m_iColLenW ;i++){
      for (int j=0;j<m_iRowLenW ;j++){
         ImgTmpNow = m_MtrImgW->fnGetBmp(i,j);
         ImgTmpOld = m_MtrImgP->fnGetBmp(i,j);
         ImgTmpNow->Height = immH;
         ImgTmpNow->Width  = immW;
         ImgTmpOld->Height = immH;
         ImgTmpOld->Width  = immW;

         BitBlt(ImgTmpNow->Canvas->Handle ,0 ,0, immW, immH, m_ImgTmp->Canvas->Handle, immW*i, immH*j, SRCCOPY);

         m_bImgCmp[i][j] = fnImgCmp(ImgTmpNow, ImgTmpOld, m_iFilter);

         ImgTmpOld->Picture->Bitmap->Assign(ImgTmpNow->Picture->Graphic );
      }
   }
   ReleaseDC(0, dcS);// hWnd
}
//-------------------------------------------------------------------------------------
bool _SrJPG::fnImgCmp(TImage *Img1, TImage *Img2, float fDat)
{
   bool bRtn = false;
   Img1->Picture->Bitmap->PixelFormat = pf24bit;
   Img2->Picture->Bitmap->PixelFormat = pf24bit;

   Byte *pLine1, *pLine2;
   Byte pRGB1[3], pRGB2[3];
   int iR1, iG1, iB1, iR2, iG2, iB2;
   float fH1, fS1, fV1, fH2, fS2, fV2;

   if(Img1->Picture->Bitmap->Width != Img2->Picture->Bitmap->Width) return true;
   if(Img1->Picture->Bitmap->Height != Img2->Picture->Bitmap->Height) return true;
   const int iDiffMgn = (Img1->Picture->Bitmap->Width/50);
   int iDiffCnt;

   for (int y=0;y<Img1->Picture->Bitmap->Height; y++){
     pLine1  = (Byte *)Img1->Picture->Bitmap->ScanLine[y];
     pLine2  = (Byte *)Img2->Picture->Bitmap->ScanLine[y];
     for (int x=0;x<Img1->Picture->Bitmap->Width; x++){
        iR1 = pLine1[x*3 + 2];
        iG1 = pLine1[x*3 + 1];
        iB1 = pLine1[x*3 + 0];
        iR2 = pLine2[x*3 + 2];
        iG2 = pLine2[x*3 + 1];
        iB2 = pLine2[x*3 + 0];

        fnRGB2HSL(iR1, iG1, iB1, fH1, fS1, fV1);
        fnRGB2HSL(iR2, iG2, iB2, fH2, fS2, fV2);
        if(fabs(fH1 - fH2) > fDat){
           if(++iDiffCnt > iDiffMgn)  return true;
        }
     }
    // iDiffCnt=0;
   }
   return bRtn;
}
//-------------------------------------------------------------------------------------
void _SrJPG::fnGray(TImage *Img, float fVar)
{
   Img->Picture->Bitmap->PixelFormat = pf24bit;
   Byte *pLine;
   Byte pRGB[3];
   int iR, iG, iB;
   float fH, fS, fV;
   for (int y=0;y<Img->Picture->Bitmap->Height; y++){
     pLine  = (Byte *)Img->Picture->Bitmap->ScanLine[y];
     for (int x=0;x<Img->Picture->Bitmap->Width; x++){
        iR = pLine[x*3 + 2];
        iG = pLine[x*3 + 1];
        iB = pLine[x*3 + 0];

        fnRGB2HSL(iR, iG, iB, fH, fS, fV);
        fnHSL2RGB(fH, fVar, fV, iR, iG, iB);

        pLine[x*3 + 2]=iR;
        pLine[x*3 + 1]=iG;
        pLine[x*3 + 0]=iB;
     }
   }
}
//---------------------------------------------------------------------------
void _SrJPG::fnSetTmpDir(String ansDir)
{
   if(ansDir == "")
      m_ansTmpDir = GetCurrentDir()+"\\VPGTmp";
   else
      m_ansTmpDir = ansDir;
   if(!DirectoryExists(m_ansTmpDir) )
      if(!CreateDir(m_ansTmpDir) )
         Application->MessageBoxA("Create aarTmp Dir Error","");

}
//--------------------------------------------------
void _SrJPG::fnCreateTmpFile(String ansName)
{
   int ipos= 0;
   m_ansCmprTmpName = "Cmpr"+ ansName;
   m_ansTmpFile = m_ansTmpDir+"\\"+ansName;
   m_ansCmprTmpFile = m_ansTmpDir+"\\"+m_ansCmprTmpName;
   m_ihdPos=0;
   if(!FileExists(m_ansTmpFile)){
      m_FileStrmW = new TFileStream(m_ansTmpFile, fmCreate);
      Sleep(10);
      //delete m_FileStrmW;
     // m_FileStrmW=0;
   }
}
//----------------------------------------------------
void _SrJPG::fnDelTmpFile()
{
   WIN32_FIND_DATA findFile;
   HANDLE hFind=0;
   String ansPath = m_ansTmpDir + "\\*.tmp";
   hFind = ::FindFirstFile(ansPath.c_str(), &findFile);
   if (hFind == INVALID_HANDLE_VALUE){
      FindClose(hFind);
      return ;
   }
   do{
      if (findFile.dwFileAttributes == FILE_ATTRIBUTE_DIRECTORY){
         if (findFile.cFileName[0] == '.')
            continue;
      }
      else{
         DeleteFile(m_ansTmpDir + "\\"+StrPas(findFile.cFileName));
      }
   }while (::FindNextFile(hFind, &findFile));
   FindClose(hFind);
}
//---------------------------------
void _SrJPG::fnSaveVPG(String ansName)
{
   TImage *ImgTmp;
   TMemoryStream *memTmp;
   int iDumpLen=0, iHeadSz;
   void *vp;
   iHeadSz = sizeof(m_vpgHeadW);
   String  NewName = m_ansTmpDir + "\\"+ansName+"."+m_ansExt;
   String  OldName = m_ansTmpDir + "\\"+m_ansTmpName;

   m_rTimer->Enabled=false;

   memTmp = m_MtrImgW->fnGetJpgMem(0,0);
   memcpy(m_vpgHeadW.szJpgHead, memTmp->Memory, g_iJpgHeadLen);

   m_Tank->fnDump(vp, iDumpLen);
   m_vpgHeadW.iVPGSize+=iDumpLen;
   m_FileStrmW->Seek(0, soFromBeginning);
   m_FileStrmW->WriteBuffer((void *)&m_vpgHeadW, iHeadSz);
   m_FileStrmW->Seek(iHeadSz, soFromBeginning);
   m_FileStrmW->WriteBuffer(m_szHeadDataW, m_vpgHeadW.iHeadDataSize);
   m_FileStrmW->Seek(0, soFromEnd);
   m_FileStrmW->Write(vp, iDumpLen);
   fnCompressionStream(m_FileStrmW, NewName+".bzip", m_zc);
   delete m_FileStrmW;
   m_FileStrmW=0;

   fnDelTmpFile();
  // RenameFile(OldName, NewName);
   ::ZeroMemory(m_szHeadDataW, sizeof(char) * m_vpgHeadW.iHeadDataSize);
   m_StartRecord=0;
}
//---------------------------------------------------------------------------
void _SrJPG::fnCompressionStream(TFileStream *Src, String ansCmprFile, TZCompressionLevel Lv)
{
   TZCompressionStream *Cmpr;
   TFileStream *ZFileStrmOut;
   ZFileStrmOut = new TFileStream(ansCmprFile, fmCreate);
   Cmpr = new TZCompressionStream(ZFileStrmOut, Lv);
   Src->Position=0;
   Cmpr->OnProgress = m_FnPt.OnCmpr;
   Cmpr->CopyFrom(Src, Src->Size);//Y
   delete Cmpr;
   delete ZFileStrmOut;
   m_FnPt.OnCmprFinish();
}
//----------------------------------------------------------------------------
void _SrJPG::fnDeCompressionStream(TFileStream *StrmOut, String ansFile)
{
   TFileStream *FileStrm=0;
   TZDecompressionStream *DeCmpr=0;
   FileStrm = new TFileStream(ansFile, fmOpenRead);
   DeCmpr = new TZDecompressionStream(FileStrm);
   DeCmpr->OnProgress = m_FnPt.OnDeCmpr;
   StrmOut->CopyFrom(DeCmpr, DeCmpr->Size); //Y
   StrmOut->Position=0;
   delete DeCmpr;
   delete FileStrm;
   m_FnPt.OnDeCmprFinish();
}
//----------------------------------------------------------------------------
_SrHead _SrJPG::fnLoadVPG(String ansFile)
{
   if(FileExists(ansFile)){
      if(!m_FileStrmR){
         m_FileStrmR = new TFileStream(ansFile+".Tmp", fmCreate);
         fnDeCompressionStream(m_FileStrmR , ansFile);
         m_FileStrmR->Read((void *)&m_vpgHeadR, sizeof(m_vpgHeadR));
         fnInitPlay();
         m_FileStrmR->Read((void *)m_szHeadDataR, m_vpgHeadR.iHeadDataSize);
      }
   }
   return m_vpgHeadR;
}
//-------------------------------------------------------------------------------
void _SrJPG::fnInitPlay()
{
   m_MtrImgR->fnInitMtr(m_vpgHeadR.iCo1Len, m_vpgHeadR.iRowLen);
   fnInitHeadDataIndxBuf(m_szHeadDataR, m_vpgHeadR.iHeadDataSize);
   m_iColLenR = m_vpgHeadR.iCo1Len;
   m_iRowLenR = m_vpgHeadR.iRowLen;
   fnSetPlayScl(1.0, 1.0);
   m_MtrImgR->fnSetPos(0,0, m_vpgHeadR.iWidth*m_fPlaySclx, m_vpgHeadR.iHeight*m_fPlayScly);
   m_pTimer->Interval=100;
}
//-------------------------------------------------------------------------------
void _SrJPG::fnSetVPGPos(unsigned int iPos)
{
   if(iPos< abs(m_vpgHeadR.iHeadDataCnt)){
      m_iPlayIndx = iPos;
      if(m_FnPt.OnMtrPlay){
         fnGetMtrImg(m_iPlayIndx, m_MtrImgR);
         m_FnPt.OnMtrPlay(m_MtrImgR, m_vpgHeadR.iCo1Len, m_vpgHeadR.iRowLen, 0);
      }
   }
}
//-------------------------------------------------------------------------------
void __fastcall _SrJPG::fnOnpTime(TObject *Sender)
{
   TDateTime Tms = EncodeTime(0, 0, 0, 1);//1 milsecond
   TDateTime tDat;
   static TDateTime tPre, tNow;
   static float fRate=20;
   int iDat, iCk;
  
   tNow = fnGetNow();
   tDat =  tNow-tPre;
   fRate = 1000./(tDat.Val/Tms.Val);
   iDat = (1000./(m_fPlayRate*m_vpgHeadR.fRealFrameRate))-(1000./fRate);
   iCk  = iDat + m_pTimer->Interval;
   if(iCk > 0){
      if(iCk < 1000)
         m_pTimer->Interval += iDat;;
   }

   if(m_FnPt.OnMtrPlay){
      m_iPlayIndx +=fnGetMtrImg(m_iPlayIndx, m_MtrImgR);
      m_FnPt.OnMtrPlay(m_MtrImgR, m_vpgHeadR.iCo1Len, m_vpgHeadR.iRowLen, fRate);
   }
   tPre = tNow;
}
//-----------------------------------------------------------------------------------
bool _SrJPG::fnReleaseVPG()
{
   bool bRtn=false;
   if(m_FileStrmR){
      delete m_FileStrmR;
      m_FileStrmR=0;
      m_pTimer->Enabled= false;
      bRtn = true;
      fnDelTmpFile();
   }
   return bRtn;
}
//------------------------------------------------------------
unsigned int _SrJPG::fnGetMtrImg(unsigned int iPos, _ImgMatrix *Mtr)
{

   unsigned int iRtn=0;
   unsigned int indx = iPos;
   static float fx=m_fPlaySclx;
   static float fy=m_fPlayScly;
   SrHeadData hd;

   unsigned __int64 iOfx;
   if(!m_FileStrmR) return 0;

   if( (fx!=m_fPlaySclx) || (fy!=m_fPlayScly) ){
      m_MtrImgR->fnSetPlayScl(m_fPlaySclx, m_fPlayScly);
      m_MtrImgR->fnSetPos(0,0, m_vpgHeadR.iWidth*m_fPlaySclx, m_vpgHeadR.iHeight*m_fPlayScly);
   }


   for (int i=0;i<m_iColLenR ;i++){
      for (int j=0;j<m_iRowLenR ;j++){
         if(indx >= abs(m_vpgHeadR.iHeadDataCnt)) return 0;

         fnReadHeadData(m_szHeadDataR, indx, hd);
         iOfx = sizeof(m_vpgHeadR) + m_vpgHeadR.iHeadDataSize + hd.iPos;
         m_memTmp->Clear();
         m_FileStrmR->Position=iOfx;

         memcpy(m_szImgBuf, m_vpgHeadR.szJpgHead, g_iJpgHeadLen);
         m_FileStrmR->ReadBuffer((void *)(m_szImgBuf+g_iJpgHeadLen), hd.iSize);
         m_memTmp->Write(m_szImgBuf, hd.iSize+g_iJpgHeadLen);
         Mtr->fnLoadFromJpgMem(m_memTmp, i, j);

         iRtn++;
         indx=iPos+iRtn;
      }
   }
   fx = m_fPlaySclx;
   fy = m_fPlayScly;
   return iRtn;
}
//-----------------------------------------------------------------------


