//---------------------------------------------------------------------------

#ifndef uSrJPGH
#define uSrJPGH
#include <vcl.h>
#include <jpeg.hpp>
#include <stdio.h>
#include <dir.h>
#include "uTank.h"
#include "ZLibEx.hpp"
//---------------------------------------------------------------------------
static const int g_iJpgHeadLen=623;
//--
typedef void __fastcall (__closure *pfFinish)();
typedef void __fastcall (__closure *pfProgess)(TObject *Sender);
typedef void __fastcall (__closure *pfMtrPlay)(_ImgMatrix *MtrImg, int iColLen, int iRowLen, float fRate);

///-----
typedef struct _strFnPt
{
   pfMtrPlay OnMtrPlay;
   pfProgess OnDeCmpr;
   pfProgess OnCmpr;
   pfFinish  OnDeCmprFinish;
   pfFinish  OnCmprFinish;
}strFnPt;

typedef struct _SrHeadData
{
   //double dTime;
  // unsigned __int64 iPos;
   float dTime;
   unsigned int iPos;
   unsigned int iSize;
}SrHeadData;
typedef struct _SrHead
{
   unsigned int iVS;
   unsigned int iWidth;
   unsigned int iHeight;
   unsigned int iCo1Len;
   unsigned int iRowLen;


   unsigned int iExpectFrameRate;
   float        fRealFrameRate;
            int iHeadDataCnt;
            int iPushDataCnt;
   double       dAllTime;
   unsigned int iHeadDataSize;
   unsigned int iVPGSize;
   char szJpgHead[g_iJpgHeadLen];
}SrHead;


class _SrJPG
{
private:
   TTimer *m_rTimer, *m_pTimer;
   TImage *m_ImgTmp ;
   TJPEGImage *m_JpgTmpR;
   TFileStream *m_FileStrmW, *m_FileStrmR;
   TMemoryStream *m_memTmp;
   char *m_szHeadDataW, *m_szHeadDataR, *m_szImgBuf;
   SrHead m_vpgHeadW, m_vpgHeadR;
   _Tank *m_Tank;
   _ImgMatrix *m_MtrImgW, *m_MtrImgR, *m_MtrImgP;

   HWND m_TGTWnd;
   TDateTime m_StartRecord;
   
   int m_iTGTTop, m_iTGTLeft, m_iTGTWidth ,m_iTGTHeight;
   int m_iColLenW, m_iRowLenW, m_iColLenR, m_iRowLenR;
   int m_iSysCx, m_iSysCy, m_iImgBufLen;
   unsigned int m_iMaxTime;//sec
   unsigned int m_iPlayIndx;
   int m_iCmpQual;
   int m_iRecordFrame;
   int m_iFilter;
   unsigned __int64 m_ihdPos;
   float m_fPlayRate;
   float m_fPlaySclx, m_fPlayScly;
   bool m_bSaveing;
   String m_ansTmpDir, m_ansTmpFile, m_ansCmprTmpFile, m_ansExt, m_ansTmpName, m_ansCmprTmpName;
   strFnPt m_FnPt;
   TZCompressionLevel m_zc;
private:
   void __fastcall fnOnrTime(TObject *Sender);
   void __fastcall fnOnpTime(TObject *Sender);
   SrHeadData **m_HeadDataPre;/*--- fnInitHeadData() uAΤ@ܼ (m_HeadDataPre) ---*/
   void fnInitHeadData(SrHeadData **&HeadData, int iColLen, int iRowLen);
   void fnCreateHeadData(SrHeadData **&HeadData, int iColLen, int iRowLen);
   void fnClearHeadData(SrHeadData **&HeadData, int iColLen, int iRowLen);

   bool **m_bImgCmp;/*--- fnInitImgCmp() uAΤ@ܼ (m_bImgCmp) ---*/
   void fnInitImgCmp(bool **&ImgCmp, int iColLen, int iRowLen);
   void fnCreateImgCmp(bool **&ImgCmp, int iColLen, int iRowLen);
   void fnClearImgCmp(bool **&ImgCmp, int iColLen, int iRowLen);

   void fnSetTmpDir(String ansDir="");
   void fnDelTmpFile();
   void fnCreateBuff();
   void fnGetTGTWndDim(HWND hWnd);
   void fnInitHeadDataIndxBuf(char *&sz, int iLen);
   void fnCreateHeadDataIndxBuf(char *&sz, int iLen);
   void fnClearHeadDataIndxBuf(char *&sz);
   void fnGetBMPFromWnd(HWND hWnd);
   void fnGray(TImage *Img, float fVar);
   void fnPushTank(_ImgMatrix *MtrNew);
   void fnWriteHeadData(char *pData, __int64 indx, SrHeadData hd);
   void fnReadHeadData (char *pData, __int64 indx, SrHeadData &hd);
   void fnSaveVPGTmp();
   void fnCreateTmpFile(String ansName);
   void fnClearHead(SrHead &Head);
   void fnInitHead(SrHead &Head);
   bool fnMemCmp(TMemoryStream *mem1, TMemoryStream *mem2);
   bool fnImgCmp(TImage *Img1, TImage *Img2, float fDat);
   unsigned int fnGetMtrImg(unsigned int iPos, _ImgMatrix *Mtr);
   void fnInitRecord(HWND hWnd);
   void fnInitPlay();
   void fnSetJpgQul(int iVar);
   void fnCompressionStream(TFileStream *Src, String ansCmprFile, TZCompressionLevel Lv);
   void fnDeCompressionStream(TFileStream *StrmOut , String ansFile);
public:
   _SrJPG(TComponent* AOwner);
   ~_SrJPG();
   void fnRecording(HWND hWnd);
   void fnRecordingSpace(bool bPause);
   void fnPlaySpace(bool bPause);
   void fnSaveVPG(String ansName);
   _SrHead fnLoadVPG(String ansFile);
   bool fnReleaseVPG();

   void fnSetInterFace(strFnPt FnPt);
   void fnSetVPGPos(unsigned int iPos);
   void fnSetFilter(int iVar);
   void fnSetCompressionQuality(int iVar);//1 ~ 100
   void fnSetRecordFrame(int iVar);
   void fnSetRecordColRow(int iColLen, int iRowLen);
   void fnSetCompressionLevel(TZCompressionLevel zc);

   void fnSetPlayScl(float fx, float fy);
   void fnSetPlayRate(float fVar);
};

#endif
