
//---------------------------------------------------------------------------
#ifndef uTankH
#define uTankH
//-----------------------------------------------
#include <vcl.h>
#include <stdio.h>
#include <math.h>
#include <algorithm>
#include <functional>
#include <Graphics.hpp>
#include <jpeg.hpp>

//---------------------------------------------------------------------------
class _ImgMatrix
{
private:
   int m_iColLen, m_iRowLen;
   int m_iColLenPre, m_iRowLenPre;
   int m_iTop, m_iLeft, m_iW, m_iH;
   int m_iSysCx, m_iSysCy;
   TImage ***m_pppBmp;
   TJPEGImage ***m_pppJpg;
   TMemoryStream ***m_pppBmpMem;
   TMemoryStream ***m_pppJpgMem;
   void fnCreate();
   void fnCreateMem(TMemoryStream ***&ppp);
   void fnCreateBmp(TImage ***&ppp);
   void fnCreateJpg(TJPEGImage ***&ppp);
   void fnClear();
   void fnClearMem(TMemoryStream ***&ppp);
   void fnClearBmp(TImage ***&ppp);
   void fnClearJpg(TJPEGImage ***&ppp);
   int m_iCmpQual;
public:
   _ImgMatrix();
   ~_ImgMatrix();
   void fnInitMtr(int iColLen, int iRowLen);
   void fnSetJpgQul(int iVar);
   void fnSetDisplayPnl(TPanel *pnl);
   void fnSetPos(int iTop, int iLeft, int iW=-1, int iH=-1);
   bool fnSeparateImg(TImage *ImgSrc);
   bool fnSeparateImg(HWND hWndSrc);
   bool fnCombineImg(TImage *Img, int iCol, int iRow, int iCCLen=-1, int iCRLen=-1);
   bool fnAssignBmp(TImage *Img, int iCol, int iRow);
   bool fnAssignMtr(_ImgMatrix *Mtr);
   TImage *fnGetBmp(int iCol, int iRow);
   TJPEGImage *fnGetJpg(int iCol, int iRow);
   TMemoryStream *fnGetBmpMem(int iCol, int iRow);
   TMemoryStream *fnGetJpgMem(int iCol, int iRow);
   bool fnLoadFromJpgMem(TMemoryStream *mem, int iCol, int iRow);
   bool fnLoadFromBmpMem(TMemoryStream *mem, int iCol, int iRow);
   void fnGetMtrInf(int &iColLen, int &iRowLen, int &iW, int &iH);
   void fnSetPlayScl(float fx, float fy);
};

class _Tank
{
private:
   int m_iVol;
   int m_iBuffPos;
   int m_iTankMagn;
   char *m_szBuff;

public:
   _Tank(int iVol);
   ~_Tank();
   void fnClear();
   int fnPush(void *pData, int &iLen);
   int  fnPull(void *&pData,int iLen);
   int  fnPull(void *&pData);
   void fnDump(void *&pData, int &iLen);
   int fnGetLen();
};
extern TDateTime fnGetNow();
extern void fnRGB2HSV(int iR, int iG, int iB, float &fH, float &fS, float &fV);
extern void fnRGB2HSL(int iR, int iG, int iB, float &fH, float &fS, float &fL);
extern void fnHSV2RGB(float fH, float fS, float fV, int &iR, int &iG, int &iB);
extern void fnHSL2RGB(float fH, float fS, float fL, int &iR, int &iG, int &iB);
///-----------------------------------------------------------------------------
#endif
